#!/bin/sh

#
# makebd.sh - genere la base de donnees de montripwire
#

ListeChemins="/bin /sbin /usr/bin /usr/sbin /etc /lib /usr/lib"
#ListeChemins="/etc"

#
# Fichier contenant les resultats (base de donnees)
#

[ -r /root ] && FIC_PERM=/root/ficperm || FIC_PERM=./ficperm

cd `dirname $0`

if [ $# -eq 1 ]
then
    FIC_PERM="$1"
elif [ $# -gt 2 ]
then
    echo "Usage : `basename $0` [fichier permissions]" 1>&2
    exit 1
fi

[ -f $FIC_PERM ] && mv $FIC_PERM $FIC_PERM.old

#
# en-tete du fichier
#

echo -e "# Nom\\tMode Proprietaire Group Taille Checksum" > $FIC_PERM
chmod 600 $FIC_PERM

(
find $ListeChemins -type f -print
[ -e /vmlinuz ] && echo /vmlinuz
for homedir in `cut -d: -f6 < /etc/passwd`
do
    [ -s $homedir/.profile ] && echo $homedir/.profile
    [ -s $homedir/.bashrc ] && echo $homedir/.bashrc
    [ -s $homedir/.bash_profile ] && echo $homedir/.bash_profile
    [ -s $homedir/.kshrc ] && echo $homedir/.kshrc
    [ -s $homedir/.tcshrc ] && echo $homedir/.tcshrc
done
) | while read fic
do

#
# -r--r--r--   1 root     root         2884 jui 26 18:48 /etc/passwd 
# ie :
#     $1 = PERM (-r--r--r--)
#     $3 = UID (root)
#     $4 = GID (root)
#     $5 = TAILLE (2884)
#     $6 $7 $8 : DATE
#

    set -- `ls -lcd $fic`
    PERM=$1
    UIDF=$3
    GIDF=$4
    TAILLE=$5
    DATE=`echo $6 $7 $8`

#
# si le fichier est executable calculer son 'checksum'
#

    if [ -x $fic ] && file $fic | egrep 'executable|commands' > /dev/null
    then
        set -- `sum $fic`
        echo -e $fic\\t$PERM $UIDF $GIDF $TAILLE $1 >> $FIC_PERM
    else
        echo -e $fic\\t$PERM $UIDF $GIDF $TAILLE x >> $FIC_PERM
    fi
done

echo "OK $FIC_PERM done."

exit 0
