#!/bin/sh

cd `dirname $0`

if [ -f "$1" ]
then
    FIC_PERM="$1"
else
    [ -r /root ] && FIC_PERM=/root/ficperm || FIC_PERM=./ficperm
fi

ISP=' 	
'
 
if [ $# -eq 1 ]
then
    FIC_PERM=$1
elif [ $# -gt 1 ]
then
    echo "Usage : $0 [fichier permissions]" 1>&2
    exit 1
fi

cat $FIC_PERM | sed "/^\#/d" | while read ligne
do
    set -- $ligne
    NOM1=$1
    PERM1=$2
    UID1=$3
    GID1=$4
    TAILLE1=$5
    SOMME1=$6

    [ ! -r $NOM1 ] && echo "Fichier $NOM1 non trouve." && continue

    set -- `ls -lcd $NOM1`
    PERM2=$1
    UID2=$3
    GID2=$4
    TAILLE2=$5

    if [ -x $NOM1 ] && file $NOM1 | egrep 'executable|commands' > /dev/null
    then
        set -- `sum $NOM1`
        SOMME2=$1
    else
        SOMME2=x
    fi

    if [ "$NOM1\\t$PERM1 $UID1 $GID1 $TAILLE1 $SOMME1" != "$NOM1\\t$PERM2 $UID2 $GID2 $TAILLE2 $SOMME2" ]
    then
        echo "$NOM1 :"
#        echo -e "# Nom\\tMode Proprietaire Group Taille Checksum"
#        echo -e "$NOM1\\t$PERM1 $UID1 $GID1 $TAILLE1 $SOMME1" 
#        echo -e "$NOM1\\t$PERM2 $UID2 $GID2 $TAILLE2 $SOMME2"
        if [ $PERM1 != $PERM2 ]
        then
            echo "permissions differentes :"
            echo -e "$PERM1\\n$PERM2"
        fi
        if [ $UID1 != $UID2 ]
        then
            echo "uid differents :"
            echo -e "$UID1\\n$UID2"
        fi
        if [ $GID1 != $GID2 ]
        then
            echo "gid differents :"
            echo -e "$GID1\\n$GID2"
        fi
        if [ $TAILLE1 != $TAILLE2 ]
        then
            echo "taille differentes :"
            echo -e "$TAILLE1\\n$TAILLE2"
        fi
        if [ $SOMME1 != $SOMME2 ]
        then
            echo "checksum differents :"
            echo -e "$SOMME1\\n$SOMME2"
        fi
        echo
    fi
done

exit 0
